﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinChart;
using Infragistics.UltraChart.Shared;
using Infragistics.UltraChart;
using Infragistics.Shared;
using System.IO;
using System.Reflection;
using Infragistics.Excel;
using Infragistics.UltraChart.Resources.Appearance;


namespace WinChartinWinGrid
{
    public partial class Form1 : Form
    {
      // Plae the xl File on your desktop and read it into the excel file.
        DataTable dtExcel = ExcelFileReader.ReadExcelFile(@"C:\Users\ktallapragada\Documents\Visual Studio 2008\Projects\WinChartinWinGrid\WinChartinWinGrid\XY List For InfraGistics Test.xls");
        DataTable newDataTable = new DataTable();
        public Form1()
        {
            InitializeComponent();
            if (!dtExcel.Columns.Contains("CHART"))
            {
                dtExcel.Columns.Add("CHART");
            }
            newDataTable = dtExcel.Clone();
            foreach (DataColumn dc in newDataTable.Columns)
            {
                if (dc.ColumnName != "XY Number")
                {
                    dc.DataType = typeof(decimal);
                }
            }

            foreach (DataRow dr in dtExcel.Rows)
            {
                newDataTable.ImportRow(dr);
            }
            
            ChartInsideGridCellDrawFilter _filter = new ChartInsideGridCellDrawFilter(this.ultraGrid1);

            _filter.ChartInfoRequested += new ChartInsideGridCellDrawFilter.ChartInfoRequestedDelegate(_filter_ChartInfoRequested);

            this.ultraGrid1.DrawFilter = _filter;
           
            ultraGrid1.DataSource = newDataTable;

        }
       
        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["CHART"].Width = 780;

            
        }

        private void Form1_DoubleClick(object sender, EventArgs e)
        {
           

        }
        void _filter_ChartInfoRequested(object Sender, ChartInfoEventArgs e)
        {
             

            try
            {
                e.WinChart.AutoSizeMode = AutoSizeMode.GrowOnly;
                DataTable modData = new DataTable();
              
                modData = newDataTable.Clone();
                e.WinChart.ChartType = Infragistics.UltraChart.Shared.Styles.ChartType.LineChart;
                e.WinChart.Axis.X.Labels.ClipText = false;
                e.WinChart.Axis.X.Labels.WrapText = true;
               
                e.WinChart.ColorModel.ModelStyle = Infragistics.UltraChart.Shared.Styles.ColorModels.CustomLinear;
               e.WinChart.ColorModel.CustomPalette = new Color[] { Color.DarkGreen, Color.Red };
                e.WinChart.TitleTop.Text ="Similarity w.r.t TC-06053 for TC Number: " + e.Row.Cells["XY Number"].Value.ToString();
                e.WinChart.LineChart.NullHandling = Infragistics.UltraChart.Shared.Styles.NullHandling.Zero;
                foreach (DataRow dr in newDataTable.Rows)
                {
                    
                        if (dr["XY Number"].ToString() == "XY-08929")
                        {
                            modData.ImportRow(dr);

                        }
                    
                }
               
                   
                                modData.ImportRow(newDataTable.Rows[e.Row.Index]);
                                    
                       
                        e.WinChart.Data.DataSource = modData;
                        e.WinChart.AutoSizeMode = AutoSizeMode.GrowOnly;
                        e.WinChart.Legend.Visible = true;
                        e.WinChart.Axis.Y.Visible = true;
                        e.WinChart.Axis.X.Labels.ClipText = false;
                        e.WinChart.Axis.X.Labels.WrapText = true;
                        e.WinChart.Axis.Y.ScrollScale.Visible = true;
                //e.WinChart.Axis.X.Labels.ItemFormatString = "<ITEM_LABEL>";
 
                    modData = null;
               
            }
            catch (Exception Ex)
            {

            }
        }

        private void ultraGrid1_DoubleClick(object sender, EventArgs e)
        {
             
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            e.Row.Height = 185;
        }

        
          
 
      

        private void ultraGridExcelExporter1_CellExported(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.CellExportedEventArgs e)
        {

            if (e == null) { return; }

            if (e.GridColumn.Key == "CHART")
            {
                Infragistics.Win.UltraWinGrid.UltraGridCell _cell = e.GridRow.Cells["CHART"];
                Image bmp = (System.Drawing.Image)_cell.Appearance.Image;
                try
                {
                    if (_cell.Appearance.Image != null)
                    {

                        PlaceImage(bmp, e);
                    }

                }
                catch (Exception ex)
                {

                }

            }




        }
        private void PlaceImage(System.Drawing.Image img, Infragistics.Win.UltraWinGrid.ExcelExport.CellExportedEventArgs e)
        {
            WorksheetImage eImg = new Infragistics.Excel.WorksheetImage(img);
            try
            {

                eImg.TopLeftCornerPosition = new System.Drawing.PointF(0, 0);
                eImg.PositioningMode = Infragistics.Excel.ShapePositioningMode.MoveAndSizeWithCells;
                eImg.TopLeftCornerPosition = new PointF(0.0F, 0.0F);
                eImg.TopLeftCornerCell = e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex];
                eImg.BottomRightCornerCell = e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex];
                eImg.BottomRightCornerPosition = new PointF(100.0F, 100.0F);

                e.CurrentWorksheet.Shapes.Add(eImg);
            }
            catch (Exception Ex)
            {
                e.CurrentWorksheet.Shapes.Add(eImg);
            }


        }

        private void ultraTabControl1_DoubleClick(object sender, EventArgs e)
        {
           

             
            try
            {
                ultraChart1.ChartType = Infragistics.UltraChart.Shared.Styles.ChartType.LineChart;
                                ultraChart1.DataSource = newDataTable;
                                ultraChart1.DataBind();
                                ultraChart1.LineChart.NullHandling = Infragistics.UltraChart.Shared.Styles.NullHandling.Zero;
                                ultraChart1.Axis.X.Labels.ClipText = false;
                                ultraChart1.Axis.X.Labels.WrapText = true;
                                //ultraChart1.Axis.X.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
            }
            catch (Exception ex)
            {

            }

        }

        private void ultraChart1_ChartDataClicked(object sender, Infragistics.UltraChart.Shared.Events.ChartDataEventArgs e)
        {

        }
         


    }
}
